package com.ctc.webbean.controller;
import java.awt.GridLayout;
import java.util.HashMap;

import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

// Class to maintain list of login's per host name and prompt user with that already entered.
public class UserLogin
{
	private HashMap login;
    JPanel      connectionPanel;
 	// Create the labels and text fields.
	JLabel     userNameLabel = new JLabel("User ID :   ", JLabel.RIGHT);
 	JTextField userNameField = new JTextField(20);
	JLabel     passwordLabel = new JLabel("Password:   ", JLabel.RIGHT);
	JTextField passwordField = new JPasswordField(20);
	JPanel namePanel = new JPanel(false);
	JPanel fieldPanel = new JPanel(false);
    // modal dialog to get user ID and password
    static String[] ConnectOptionNames = { "Login", "Cancel" };
	String ConnectTitle;

	public class accessInfo
	{
		String host;
		String userID;
		String userPassword;
		accessInfo()
		{
		}
	}	

     public UserLogin(String title) {
		ConnectTitle = title;
		login = new HashMap();
		connectionPanel = new JPanel(false);
		connectionPanel.setLayout(new BoxLayout(connectionPanel,
							BoxLayout.X_AXIS));
		namePanel.setLayout(new GridLayout(0, 1));
		namePanel.add(userNameLabel);
		namePanel.add(passwordLabel);
		fieldPanel.setLayout(new GridLayout(0, 1));
		fieldPanel.add(userNameField);
		fieldPanel.add(passwordField);
		connectionPanel.add(namePanel);
		connectionPanel.add(fieldPanel);
    }

	public String getUserID(Object obj)
	{
		accessInfo info = (accessInfo)obj;
		return info.userID;
	}

	public String getUserPassword(Object obj)
	{
		accessInfo info = (accessInfo)obj;
		return info.userPassword;
	}

	// prompt user for login information and if did before just show previous entries as default
    public Object getUserLogin(String host) 
    {
		String id;
		String password;

		accessInfo user = (accessInfo)login.get(host);
		if (user == null)
		{		
			id = "";
			password = "";
		}
		else
		{
			// pre-initialize the data
			id = user.userID;
			password = user.userPassword;
		}
		userNameField.setText(id);
		passwordField.setText(password);
		id = "";
		password = "";

	        // Connect or quit
		while (id.equals("") || password.equals(""))
		{
			if (JOptionPane.showOptionDialog(null, connectionPanel, 
		                                        ConnectTitle,
		                                        JOptionPane.OK_CANCEL_OPTION, 
		                                        JOptionPane.INFORMATION_MESSAGE,
		                                        null, ConnectOptionNames, 
		                                        ConnectOptionNames[0]) != 0) 
		    {
			    return null;
			}
		    id = userNameField.getText();
		    password = passwordField.getText();
		}
		// have new info
		if (user != null)
		{
			// simply update the object
			user.userID = id;
			user.userPassword = password;
		}
		else
		{
			// new entry
			user = new accessInfo();
			user.userID = id;
			user.userPassword = password;
			user.host = host;
			login.put(user.host,user);
		}
		return user;
	}
}
